; 11MVWGDE.LSP - C:GD      - draw guide line in MSPACE to define limits of VPORT

; By Edward M. Malins  Kraus, Malins & Associates  Montreal CIS # 72377,1057


; Revision date : 94-08-09
; Revision      : Added list of called routines,
                  if nec., change viewport to layer VP 

; Called routines
; DXF  GETMODE  SETMODE


; MVGUIDE - main routine

(defun mvguide (/ cnt ctr en fl p1 p2 p3 p4 scl2 ss vno vsz xc xsz yc ysz)
 (if (= (getvar "TILEMODE") 1)
  (progn
   (setvar "TILEMODE" 0)
   (command "PSPACE")
 ))
 (if (= (getvar "CVPORT") 1)  ; if in PSpace, set fl T and set req'd VP current
  (progn
   (setq fl T)
   (command "MSPACE")
   (getpoint "\nPick in Viewport which requires guideline")
 ))
 (setq
  ctr (getvar "VIEWCTR")  ;centrepoint of viewport
  vsz (getvar "VIEWSIZE") ;height of viewport
  vno (getvar "CVPORT")   ;no. of current viewport
 )
 (command "PSPACE")
 (setq
  ss (ssget "X" '((0 . "VIEWPORT"))) ;get selection set of viewports
  cnt -1
 )
 (while (and cnt (< (setq cnt (1+ cnt)) (sslength ss))) ; find which selected
  (setq en (entget (ssname ss cnt)))
  (if (= (dxf 69 en) vno) (setq cnt nil))
 )
 (setq            ;get VP data
  xsz (dxf 40 en) 
  ysz (dxf 41 en)
  scl (/ vsz ysz) ;calculate scale and corners in MSpace
  sclstr (strcat   "Viewport Scale is 1:" (itoa scl))
  xc  (car ctr)
  yc  (cadr ctr)
  dx  (* xsz scl 0.5)
  dy  (* ysz scl 0.5)
  p1 (list (- xc dx) (- yc dy))
  p2 (list (+ xc dx) (- yc dy))
  p3 (list (+ xc dx) (+ yc dy))
  p4 (list (- xc dx) (+ yc dy))
 )
 (command    draw guideline and make it yellow
  "MSPACE"
  "LAYER" "M" "VP" ""
  "PLINE" p1 "W" 0 0 p2 p3 p4 "C"
  "CHANGE" (entlast) "" "P" "C" "YELLOW" ""
 )
 (if (/= (dxf 8 en) "VP") (entmod (subst (cons 8 "VP") (assoc 8 en) en)))
 (if fl (command "PSPACE"))  ; return to PSpace if necessary
 (if (= "12" (getvar "ACADVER")) (alert  sclstr) (prompt (strcat "\n" sclstr)))
 (princ)
)


; GETMODE - establish changeable variables which are to be reset
;           at end of program and initialize error program

(defun getmode (mod1 / mod)
 (repeat (length mod1)
  (setq 
   mod (append mod (list (list (car mod1) (getvar (car mod1)))))
   mod1 (cdr mod1)
 ))
 mod
)


; SETMODE - reset variables and error system

(defun setmode (mod1)
 (repeat (length mod1)
  (setvar (caar mod1) (cadar mod1))
  (setq mod1 (cdr mod1))
 )
)


; DXF - extract DXF code from list

(defun dxf (code elist) (cdr (assoc code elist)))


; C:GD - command line access to function

(defun C:GD (/ prgmod)
 (setq prgmod (getmode '("TILEMODE" "CLAYER" "OSMODE")))
 (setvar "OSMODE" 0)
 (mvguide)
 (setmode prgmod)
 (princ)
)

(princ "\nMWWGDE.LSP loaded.  Enter GD to start")

(princ)
